;Always the first step: load the VIGRA CL Lib
(require 'asdf) 
(asdf:operate 'asdf:load-op 'vigracl)

(in-package :vigracl)

(defvar imgdir (truename "."))
(defvar img (loadimage (namestring (merge-pathnames imgdir "cells.jpg"))))
(show-image img)

(defvar mask (image-map #'(lambda (x) (if (< x 220.0)
                                        255.0
                                        0.0))
                        (image->red img)))
(show-image mask)

(defvar omask (openingimage mask 1))
(show-image omask)

(defvar labelimg (labelimage omask T 0.0))

(defvar stats (extractfeatures img labelimg))

(defun circle-like? (region threshold)
    (let* ((width (- (image-ref stats region 3 0)
                     (image-ref stats region 1 0)))
            (height (- (image-ref stats region 4 0)
                      (image-ref stats region 2 0)))
        	(a (max width height))
        	(b (min width height)))
       (< (/ a b) threshold)))


(defvar maxlabel (round (car (image-reduce #'max labelimg 0.0))))
(defvar label-ids (loop for i from 1 to maxlabel collect i))
(defvar filtered-ids (remove-if-not #'(lambda (x) (circle-like? x 4/3)) label-ids))

(defvar circle-likes
 (image-map #'(lambda (v) (if (and (> v 0.0)
                                 (not (null  (member (round v) filtered-ids))))
                            255.0
                            0.0))
            labelimg))

(defvar non-circle-likes
 (image-map #'(lambda (v) (if (and (> v 0.0)
                                 (null (member (round v) filtered-ids)))
                            255.0
                            0.0))
            labelimg))
(defvar empty (make-image (image-width omask) (image-height omask) 1 0.0))

(defvar result (list (car non-circle-likes) (car circle-likes) (car empty)))
(show-image result)
(saveimage result (namestring (merge-pathnames imgdir "result.png")))
